/*
 * Implementation of IWebBrowser interface for IE Web Browser control
 *
 * 2001 John R. Sheets (for CodeWeavers)
 */

#include "debugtools.h"
#include "shdocvw.h"

DEFAULT_DEBUG_CHANNEL(shdocvw);

/**********************************************************************
 * Implement the IWebBrowser interface
 */

static HRESULT WINAPI WB_QueryInterface(LPWEBBROWSER iface, REFIID riid, LPVOID *ppobj)
{
    ICOM_THIS(IWebBrowserImpl, iface);

    FIXME("(%p)->(%s,%p),stub!\n", This, debugstr_guid(riid), ppobj);
    return E_NOINTERFACE;
}

static ULONG WINAPI WB_AddRef(LPWEBBROWSER iface)
{
    ICOM_THIS(IWebBrowserImpl, iface);

    TRACE("\n");
    return ++(This->ref);
}

static ULONG WINAPI WB_Release(LPWEBBROWSER iface)
{
    ICOM_THIS(IWebBrowserImpl, iface);

    /* static class, won't be freed */
    TRACE("\n");
    return --(This->ref);
}

/* IDispatch methods */
static HRESULT WINAPI WB_GetTypeInfoCount(LPWEBBROWSER iface, UINT *pctinfo)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_GetTypeInfo(LPWEBBROWSER iface, UINT iTInfo, LCID lcid,
                                     LPTYPEINFO *ppTInfo)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_GetIDsOfNames(LPWEBBROWSER iface, REFIID riid,
                                       LPOLESTR *rgszNames, UINT cNames,
                                       LCID lcid, DISPID *rgDispId)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_Invoke(LPWEBBROWSER iface, DISPID dispIdMember,
                                REFIID riid, LCID lcid, WORD wFlags,
                                DISPPARAMS *pDispParams, VARIANT *pVarResult,
                                EXCEPINFO *pExepInfo, UINT *puArgErr)
{
    FIXME("stub dispIdMember = %d, IID = %s\n", (int)dispIdMember, debugstr_guid(riid));
    return S_OK;
}

/* IWebBrowser methods */
static HRESULT WINAPI WB_GoBack(LPWEBBROWSER iface)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_GoForward(LPWEBBROWSER iface)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_GoHome(LPWEBBROWSER iface)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_GoSearch(LPWEBBROWSER iface)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_Navigate(LPWEBBROWSER iface, BSTR *URL,
                                  VARIANT *Flags, VARIANT *TargetFrameName,
                                  VARIANT *PostData, VARIANT *Headers)
{
    FIXME("stub: URL = %p (%p, %p, %p, %p)\n", URL, Flags, TargetFrameName,
          PostData, Headers);
    return S_OK;
}

static HRESULT WINAPI WB_Refresh(LPWEBBROWSER iface)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_Refresh2(LPWEBBROWSER iface, VARIANT *Level)
{
    FIXME("stub: %p\n", Level);
    return S_OK;
}

static HRESULT WINAPI WB_Stop(LPWEBBROWSER iface)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_Application(LPWEBBROWSER iface, LPVOID *ppDisp)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_Parent(LPWEBBROWSER iface, LPVOID *ppDisp)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_Container(LPWEBBROWSER iface, LPVOID *ppDisp)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_Document(LPWEBBROWSER iface, LPVOID *ppDisp)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_TopLevelContainer(LPWEBBROWSER iface, VARIANT *pBool)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_Type(LPWEBBROWSER iface, BSTR *Type)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_Left(LPWEBBROWSER iface, long *pl)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_put_Left(LPWEBBROWSER iface, long Left)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_Top(LPWEBBROWSER iface, long *pl)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_put_Top(LPWEBBROWSER iface, long Top)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_Width(LPWEBBROWSER iface, long *pl)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_put_Width(LPWEBBROWSER iface, long Width)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_Height(LPWEBBROWSER iface, long *pl)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_put_Height(LPWEBBROWSER iface, long Height)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_LocationName(LPWEBBROWSER iface, BSTR *LocationName)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_LocationURL(LPWEBBROWSER iface, BSTR *LocationURL)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WINAPI WB_get_Busy(LPWEBBROWSER iface, VARIANT *pBool)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_Quit()
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_ClientToWindow( int* pcx, int* pcy) 
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_PutProperty(BSTR Property, VARIANT vtValue)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_GetProperty(BSTR Property, VARIANT* pvtValue)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_Name(BSTR* Name)
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_HWND (long* pHWND) 
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_FullName (BSTR* FullName)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_Path (BSTR*  Path)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_Visible (VARIANT_BOOL* pBool) 
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_Visible(VARIANT_BOOL Value) 
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_StatusBar (VARIANT_BOOL* pBool) 
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_StatusBar (VARIANT_BOOL Value)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_StatusText (BSTR* StatusText)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_StatusText (BSTR StatusText)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_ToolBar (int* Value)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_ToolBar (int Value)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_MenuBar (VARIANT_BOOL* Value)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_MenuBar (VARIANT_BOOL Value)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_FullScreen (VARIANT_BOOL*  pbFullScreen)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_FullScreen (VARIANT_BOOL bFullScreen)   
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_Navigate2 (VARIANT* URL, VARIANT* Flags, VARIANT* TargetFrameName, VARIANT* PostData, VARIANT* Headers)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_QueryStatusWB( OLECMDID cmdID, OLECMDF* pcmdf)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_ExecWB( OLECMDID cmdID, OLECMDEXECOPT cmdexecopt, VARIANT* pvaIn, VARIANT* pvaOut)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_ShowBrowserBar( VARIANT* pvaClsid, VARIANT* pvarShow, VARIANT* pvarSize)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_ReadyState( READYSTATE* plReadyState)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_Offline (VARIANT_BOOL* pbOffline)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_Offline (VARIANT_BOOL bOffline)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_Silent (VARIANT_BOOL* pbSilent)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_Silent (VARIANT_BOOL bSilent)   
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_RegisterAsBrowser (VARIANT_BOOL* pbRegister)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_RegisterAsBrowser (VARIANT_BOOL bRegister)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_RegisterAsDropTarget (VARIANT_BOOL* pbRegister)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_RegisterAsDropTarget (VARIANT_BOOL bRegister)   
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_TheaterMode (VARIANT_BOOL* pbRegister)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_TheaterMode (VARIANT_BOOL bRegister)   
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_AddressBar (VARIANT_BOOL* Value)   
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_AddressBar (VARIANT_BOOL Value)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_get_Resizable (VARIANT_BOOL* Value)  
{
    FIXME("stub \n");
    return S_OK;
}

static HRESULT WB2_put_Resizable (VARIANT_BOOL Value) 
{
    FIXME("stub \n");
    return S_OK;
}

/**********************************************************************
 * IWebBrowser virtual function table for IE Web Browser component
 */

static ICOM_VTABLE(IWebBrowser) WB_Vtbl =
{
    ICOM_MSVTABLE_COMPAT_DummyRTTIVALUE
    WB_QueryInterface,
    WB_AddRef,
    WB_Release,
    WB_GetTypeInfoCount,
    WB_GetTypeInfo,
    WB_GetIDsOfNames,
    WB_Invoke,
    WB_GoBack,
    WB_GoForward,
    WB_GoHome,
    WB_GoSearch,
    WB_Navigate,
    WB_Refresh,
    WB_Refresh2,
    WB_Stop,
    WB_get_Application,
    WB_get_Parent,
    WB_get_Container,
    WB_get_Document,
    WB_get_TopLevelContainer,
    WB_get_Type,
    WB_get_Left,
    WB_put_Left,
    WB_get_Top,
    WB_put_Top,
    WB_get_Width,
    WB_put_Width,
    WB_get_Height,
    WB_put_Height,
    WB_get_LocationName,
    WB_get_LocationURL,
    WB_get_Busy
};

IWebBrowserImpl SHDOCVW_WebBrowser = { &WB_Vtbl, 1 };


/**********************************************************************
 * IWebBrowser2 virtual function table for IE Web Browser component
 */

static ICOM_VTABLE(IWebBrowser2) WB2_Vtbl =
{
    ICOM_MSVTABLE_COMPAT_DummyRTTIVALUE
    WB_QueryInterface,
    WB_AddRef,
    WB_Release,
    WB_GetTypeInfoCount,
    WB_GetTypeInfo,
    WB_GetIDsOfNames,
    WB_Invoke,
    WB_GoBack,
    WB_GoForward,
    WB_GoHome,
    WB_GoSearch,
    WB_Navigate,
    WB_Refresh,
    WB_Refresh2,
    WB_Stop,
    WB_get_Application,
    WB_get_Parent,
    WB_get_Container,
    WB_get_Document,
    WB_get_TopLevelContainer,
    WB_get_Type,
    WB_get_Left,
    WB_put_Left,
    WB_get_Top,
    WB_put_Top,
    WB_get_Width,
    WB_put_Width,
    WB_get_Height,
    WB_put_Height,
    WB_get_LocationName,
    WB_get_LocationURL,
    WB_get_Busy,
    WB2_Quit,
    WB2_ClientToWindow,
    WB2_PutProperty,
    WB2_GetProperty,
    WB2_get_Name,
    WB2_get_HWND,
    WB2_get_FullName,
    WB2_get_Path,
    WB2_get_Visible,
    WB2_put_Visible,
    WB2_get_StatusBar,
    WB2_put_StatusBar,
    WB2_get_StatusText,
    WB2_put_StatusText,
    WB2_get_ToolBar,
    WB2_put_ToolBar,
    WB2_get_MenuBar,
    WB2_put_MenuBar,
    WB2_get_FullScreen,
    WB2_put_FullScreen,
    WB2_Navigate2,
    WB2_QueryStatusWB,
    WB2_ExecWB,
    WB2_ShowBrowserBar,
    WB2_get_ReadyState,
    WB2_get_Offline,
    WB2_put_Offline,
    WB2_get_Silent,
    WB2_put_Silent,
    WB2_get_RegisterAsBrowser,
    WB2_put_RegisterAsBrowser,
    WB2_get_RegisterAsDropTarget,
    WB2_put_RegisterAsDropTarget,
    WB2_get_TheaterMode,
    WB2_put_TheaterMode,
    WB2_get_AddressBar,
    WB2_put_AddressBar,
    WB2_get_Resizable,
    WB2_put_Resizable
};

IWebBrowser2Impl SHDOCVW_WebBrowser2 = { &WB2_Vtbl, 1 };
