/*
 * Wine library reentrant errno support
 *
 * Copyright 1998 Alexandre Julliard
 */

#include "config.h"

static int *default_errno_location(void);
static int *default_h_errno_location(void);

#include <errno.h>
#include <netdb.h>

int* (*wine_errno_location)(void) = default_errno_location;
int* (*wine_h_errno_location)(void) = default_h_errno_location;

static int fake_errno;
static int fake_h_errno;

static int *default_errno_location(void)
{
    return &fake_errno;
}

static int *default_h_errno_location(void)
{
    return &fake_h_errno;
}

#if !defined( USE_PTHREADS )

extern int* (*wine_errno_location)(void);
extern int* (*wine_h_errno_location)(void);
                                                                                                                                                                                      
/***********************************************************************
 *           __errno_location/__error/___errno
 *
 * Get the per-thread errno location.
 */
#ifdef ERRNO_LOCATION
int *ERRNO_LOCATION(void)
{
    return wine_errno_location();
}
#endif /* ERRNO_LOCATION */
                                                                                                                                                                                      
/***********************************************************************
 *           __h_errno_location
 *
 * Get the per-thread h_errno location.
 */
int *__h_errno_location(void)
{
    return wine_h_errno_location();
}


#endif

